Bug 549366 - Review Request: flaw - Free top-down wizard battle game
Summary: Review Request: flaw - Free top-down wizard battle game
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Andrea Musuruane
QA Contact: Fedora Extras Quality Assurance
URL: http://flaw.sourceforge.net/
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-12-21 13:41 UTC by Filipe Rosset
Modified: 2010-04-24 05:03 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-04-24 05:03:47 UTC
musuruan: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Filipe Rosset 2009-12-21 13:41:22 UTC
Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2-1.fc12.src.rpm

F.L.A.W is a small multiplayer action game. It can be played by up to 5 players
simultaneously. Each player controls a wizard. The goal of the game is to
survive as long as possible while more and more fireballs appear on the screen.

Tested with rpmlint, mock and koji.
Koji results: https://koji.fedoraproject.org/koji/taskinfo?taskID=1882983

This is my first package.

Comment 1 Fabian Affolter 2009-12-21 21:07:03 UTC
Just some quick comments on your spec file:

- You should recheck the license.  'either version 3 of the License, or
 (at your option) any later version.'
- Are you listed requirements in Requires: automatically picked by rpm?

Comment 2 Itamar Reis Peixoto 2009-12-21 21:26:47 UTC
I think you can replace

%{_bindir}/flaw*

with

%{_bindir}/flaw

please fix these things and post a updated spec + src.rpm, remember to bump version in spec file.

Comment 3 Filipe Rosset 2009-12-22 12:13:52 UTC
Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2-2.fc12.src.rpm

New files with the corrections identified in comments 1 and 2.

Comment 4 Alagunambi Welkin 2009-12-27 12:21:26 UTC
Hi,


Just a quick review suggestion,

you can change the Source0 value to

http://downloads.sourceforge.net/flaw/flaw-1.2.tar.gz



Alagunambi Welkin

Comment 5 Fabian Affolter 2009-12-27 21:06:19 UTC
(In reply to comment #4) 
> you can change the Source0 value to
> 
> http://downloads.sourceforge.net/flaw/flaw-1.2.tar.gz

But I would like to suggest still to use macros.  It's much easier to maintain.  Changing the version in the Source0 with every update just sucks ;-)

Comment 6 Alagunambi Welkin 2009-12-28 04:37:08 UTC
(In reply to comment #5)
> (In reply to comment #4) 
> > you can change the Source0 value to
> > 
> > http://downloads.sourceforge.net/flaw/flaw-1.2.tar.gz
> 
> But I would like to suggest still to use macros.  It's much easier to maintain.
>  Changing the version in the Source0 with every update just sucks ;-)  

Ooops! I forgot to mention to add macros instead of name, version, all I suggested to change the link address, thanks the pointing it!

Comment 7 Filipe Rosset 2009-12-29 12:58:56 UTC
Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2.1-3.fc12.src.rpm

- Now fixed Source0 url (use macros and short url)
- Updated to version 1.2.1 (upstream source code)

Comment 8 Andrea Musuruane 2010-01-02 13:33:33 UTC
You must not install irrelevant files like the INSTALL file in %doc:
http://fedoraproject.org/wiki/Packaging/Guidelines#Documentation

Comment 9 Andrea Musuruane 2010-02-21 13:40:23 UTC
Can you please fix what I reported in comment #8 and package the latest release (v.1.2.2)?

Comment 10 Filipe Rosset 2010-02-21 22:10:37 UTC
Hi Musuruane

Now and fix your comment #8 and the lastest release.


Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2.2-4.fc12.src.rpm

- Removed irrelevant files in doc
- Updated to version 1.2.2 upstream source

Comment 11 Andrea Musuruane 2010-03-14 17:44:55 UTC
Here is the review:

 +:ok, =:needs attention, -:needs fixing, /:not applicable

MUST Items:
[-] MUST: rpmlint must be run on every package.

$ rpmlint /home/andrea/rpmbuild/SRPMS/flaw-1.2.2-4.fc12.src.rpm
flaw.src: W: spelling-error Summary(en_US) multiplayer -> multiplexer, multiplier, multiplicity
flaw.src: W: spelling-error %description -l en_US multiplayer -> multiplexer, multiplier, multiplicity
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

$ rpmlint /home/andrea/rpmbuild/RPMS/x86_64/flaw-1.2.2-4.fc12.x86_64.rpm
flaw.x86_64: W: spelling-error Summary(en_US) multiplayer -> multiplexer, multiplier, multiplicity
flaw.x86_64: W: spelling-error %description -l en_US multiplayer -> multiplexer, multiplier, multiplicity
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

$ rpmlint /home/andrea/rpmbuild/RPMS/x86_64/flaw-debuginfo-1.2.2-4.fc12.x86_64.rpm
flaw-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/flaw-1.2.2/src/framerate.h
flaw-debuginfo.x86_64: E: script-without-shebang /usr/src/debug/flaw-1.2.2/src/main.cc
flaw-debuginfo.x86_64: E: script-without-shebang /usr/src/debug/flaw-1.2.2/src/wizard.cc
flaw-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/flaw-1.2.2/src/wizard.h
flaw-debuginfo.x86_64: E: script-without-shebang /usr/src/debug/flaw-1.2.2/src/game.cc
flaw-debuginfo.x86_64: E: script-without-shebang /usr/src/debug/flaw-1.2.2/src/framerate.cc
flaw-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/flaw-1.2.2/src/game.h
flaw-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/flaw-1.2.2/src/menu.h
flaw-debuginfo.x86_64: E: script-without-shebang /usr/src/debug/flaw-1.2.2/src/menu.cc
flaw-debuginfo.x86_64: E: script-without-shebang /usr/src/debug/flaw-1.2.2/src/fireball.cc
flaw-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/flaw-1.2.2/src/fireball.h
1 packages and 0 specfiles checked; 6 errors, 5 warnings.

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}
[-] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
15b1208a3e8036377068586d1bdc118cd1fb4a8b  flaw-1.2.2.tar.gz
15b1208a3e8036377068586d1bdc118cd1fb4a8b  ../SOURCES/flaw-1.2.2.tar.gz
[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
Tested on F12/x86_64
[+] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro.
[/] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review
[/] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines.
[+] MUST: The package must contain code, or permissible content. This is described in detail in the code vs. content section of Packaging Guidelines.
[/] MUST: Large documentation files should go in a doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[/] MUST: Header files must be in a -devel package.
[/] MUST: Static libraries must be in a -static package.
[/] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[/] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[/] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
[/] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[+] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[/] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
Tested on devel/x86_64
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[+] SHOULD: The reviewer should test that the package functions as described.
Tested on F12/x86_64
[/] SHOULD: If scriptlets are used, those scriptlets must be sane.
[/] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[/] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[=] SHOULD: Packages should try to preserve timestamps of original installed files.


Issues:

1. Please, always post rpmlint output when you submit a package review. The spurious-executable-perm and script-without-shebang errors must be fixed removing the executable premissions in %prep.

2. This is not correct:
Source1:        %{name}-%{version}/data/%{name}.desktop

Why did you place that in a subdir? Anyway, rpmbuild ignore this.

3. There is also something wrong in this:
%configure --docdir=%{_docdir}/%{name}-%{version}

When you then use %doc to mark documentation files, the docdir you already installed with "make install" is wiped out.

[..]
test -z "/usr/share/doc/flaw-1.2.2" || /bin/mkdir -p "/builddir/build/BUILDROOT/
flaw-1.2.2-4.fc14.x86_64/usr/share/doc/flaw-1.2.2"
 /usr/bin/install -c -m 644 README COPYING AUTHORS ChangeLog INSTALL '/builddir/
build/BUILDROOT/flaw-1.2.2-4.fc14.x86_64/usr/share/doc/flaw-1.2.2'
[..]
+ DOCDIR=/builddir/build/BUILDROOT/flaw-1.2.2-4.fc14.x86_64/usr/share/doc/flaw-1.2.2
+ export DOCDIR
+ rm -rf /builddir/build/BUILDROOT/flaw-1.2.2-4.fc14.x86_64/usr/share/doc/flaw-1.2.2
+ /bin/mkdir -p /builddir/build/BUILDROOT/flaw-1.2.2-4.fc14.x86_64/usr/share/doc/flaw-1.2.2
+ cp -pr COPYING AUTHORS ChangeLog README /builddir/build/BUILDROOT/flaw-1.2.2-4.fc14.x86_64/usr/share/doc/flaw-1.2.2
[..]

Please see:
https://fedoraproject.org/wiki/How_to_create_an_RPM_package#.25files_prefixes

I suggest you not to use %doc to mark documentation files. You will also have to manually remove the INSTALL file (in %install) and mark the documentation directory like this (in %files):
%doc %{_docdir}/%{name}-%{version}

4. You should try to preserves the files' timestamps, eg. cp -p or install -p. 
https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps


Please fix at least 1, 2 and 3 and I'll approve this package.


NEEDSWORK

Comment 12 Andrea Musuruane 2010-03-27 14:11:34 UTC
Are you still interested in this review? Otherwise, please close it as WONTFIX.

Comment 13 Filipe Rosset 2010-03-27 14:24:46 UTC
Yes, I'll work on that now.

Comment 14 Filipe Rosset 2010-03-27 14:41:10 UTC
Issues 1, 2 and 4 now fixed.
I have to solve difficult issue # 3 on comment # 11
I stopped at this point, i need help.

Comment 15 Andrea Musuruane 2010-03-27 19:10:45 UTC
(In reply to comment #14)
> I have to solve difficult issue # 3 on comment # 11
> I stopped at this point, i need help.    

I'll try to explain it better.

In the %install section, remove the INSTALL file:
rm %{_docdir}/%{name}-%{version}/INSTALL

Replace this line in the %files section:
%doc COPYING AUTHORS ChangeLog README

With the following line:
%doc %{_docdir}/%{name}-%{version}

You can check what files are marked as documentation in the RPM with:
rpm -qpd <package_name>

That's it :-)

Comment 16 Filipe Rosset 2010-03-27 22:17:29 UTC
Thanks Musuruane!

I think that now is all right.

Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2.2-5.fc12.src.rpm

Changelog
* Sat Mar 27 2010 Filipe Rosset <rosset.filipe@gmail.com> - 1.2.2-5
- Fix shebang on rpmlint, now is silent
- Fix location and incorrect lines of flaw.desktop
- Fix files timestamps
- Fix documentation files

Comment 17 Andrea Musuruane 2010-03-28 09:12:36 UTC
First, you can begin calling me using my first name and not my surname. I think that this review makes me an acquaintance :-)

* Please remove commented Source1 lines, since you don't use them.

* Now you are mixing macro styles:
https://fedoraproject.org/wiki/Packaging:Guidelines#Using_.25.7Bbuildroot.7D_and_.25.7Boptflags.7D_vs_.24RPM_BUILD_ROOT_and_.24RPM_OPT_FLAGS

* Issue 4 is still not solved. You did a funny thing. "install -p" is a command not a make option.

This is not a mandatory issue. If you want to fix it, please read again:
https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps

* The following comment 
#fix shebang on rpmlint

should be better changed to:
# Fix spurious executable permissions

* If desktop file is already installed by the install process (and what is installed is semantically correct), use desktop-file-validate instead of desktop-file-install:
https://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage

* Please report the bugs you found in the desktop file upstream.

Comment 18 Filipe Rosset 2010-03-29 03:13:11 UTC
Hi Andrea.

Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL:
http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2.2-6.fc12.src.rpm

%changelog
* Mon Mar 28 2010 Filipe Rosset <rosset.filipe@gmail.com> - 1.2.2-6
- Fix spec issues

Comment 19 Andrea Musuruane 2010-03-29 09:13:22 UTC
You are still mixing macro styles. Please change the following line from:

desktop-file-validate %{buildroot}/%{_datadir}/applications/%{name}.desktop

to:
desktop-file-validate $RPM_BUILD_ROOT%{_datadir}/applications/%{name}.desktop

Also note that both $RPM_BUILD_ROOT and %{buildroot} already have the tailing slash therefore there is no need to add it. You can check this with:

rpm --eval %{buildroot}

Comment 20 Filipe Rosset 2010-03-29 14:25:04 UTC
Hi Andrea.

Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL:
http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2.2-7.fc12.src.rpm

%changelog
* Mon Mar 29 2010 Filipe Rosset <rosset.filipe@gmail.com> - 1.2.2-7
- Fix spec issues

Comment 21 Andrea Musuruane 2010-03-29 14:31:03 UTC
Filipe, I just noticed you no longer put doc files in %{_docdir}/%{name}-%{version} but in %{_docdir}/%{name}. This is wrong, according to FPG.

Moreover, you must not use %{_datadir}/doc but %{_docdir}.

Comment 22 Filipe Rosset 2010-03-29 14:41:12 UTC
Ok, i changed %{_datadir}/doc to %{_docdir}

If i use %{_docdir}/%{name}-%{version} instead of %{_docdir}/%{name} i have this errors:


test -z "/usr/share/doc/flaw" || /bin/mkdir -p "/home/rosset/rpmbuild/BUILDROOT/flaw-1.2.2-7.fc12.x86_64/usr/share/doc/flaw"
 /usr/bin/install -c -m 644 README COPYING AUTHORS ChangeLog INSTALL '/home/rosset/rpmbuild/BUILDROOT/flaw-1.2.2-7.fc12.x86_64/usr/share/doc/flaw'

Processing files: flaw-1.2.2-7.fc12.x86_64
error: File not found: /home/rosset/rpmbuild/BUILDROOT/flaw-1.2.2-7.fc12.x86_64/usr/share/doc/flaw-1.2.2


RPM build error:
    File not found: /home/rosset/rpmbuild/BUILDROOT/flaw-1.2.2-7.fc12.x86_64/usr/share/doc/flaw-1.2.2

Comment 23 Filipe Rosset 2010-03-29 14:45:14 UTC
This is a upstream bug?

Comment 24 Andrea Musuruane 2010-03-29 19:08:56 UTC
Anyway, (In reply to comment #23)
> This is a upstream bug?    

No. I really believe it is an error in your spec files. I did the required modification on my local copy and it is OK.
 
$ rpm -qpd /home/andrea/rpmbuild/RPMS/x86_64/flaw-1.2.2-5.fc12.x86_64.rpm
/usr/share/doc/flaw-1.2.2/AUTHORS
/usr/share/doc/flaw-1.2.2/COPYING
/usr/share/doc/flaw-1.2.2/ChangeLog
/usr/share/doc/flaw-1.2.2/README


I just called configure in this way:
%configure --docdir=%{_docdir}/%{name}-%{version}

And changed the %files section like the following:
%files
[...]
%exclude %{_docdir}/%{name}-%{version}/INSTALL
%doc %{_docdir}/%{name}-%{version}


If you have further problems, please post your latest SPEC and src.rpm.

Comment 25 Filipe Rosset 2010-03-30 21:05:54 UTC
Hi Andrea.

Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL:
http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2.2-8.fc12.src.rpm

%changelog
* Tue Mar 30 2010 Filipe Rosset <rosset.filipe@gmail.com> - 1.2.2-8
- Fix spec issues

Comment 26 Andrea Musuruane 2010-04-02 13:07:02 UTC
I'm sorry but I just discovered another blocking issue. 

There are fonts embedded in this package:
http://fedoraproject.org/wiki/Packaging/Guidelines#Avoid_bundling_of_fonts_in_other_packages

Please note that these fonts seem to be already available in:
tulrich-tuffy-fonts.noarch

All the rest is fine now.

Comment 27 Andrea Musuruane 2010-04-09 17:21:16 UTC
Filipe, if you don't know how to fix the problem with embedded fonts, I think you can find a bit of help in this spec file:

http://cvs.fedoraproject.org/viewvc/devel/zaz/zaz.spec?revision=1.2&view=markup

Please ask if you need more help.

Comment 28 Denis Comtesse 2010-04-10 17:55:14 UTC
Hi everyone,
I'm the developer of this little game and found that review request today.
The problem with embedded fonts will be solved upstream with the next release in a few days. I'm going to change the configure script, so that the correct font directory can be set through a command line option. Then it won't be necessary to include any fonts in the package.

Comment 29 Filipe Rosset 2010-04-11 22:06:22 UTC
OK Denis.
I'm waiting you to update this package with the new features.

Comment 30 Denis Comtesse 2010-04-13 15:08:35 UTC
It's done. FLAW 1.2.3 has been released and comes without embedded fonts. The game now depends on GNU FreeFont. You can set the '--enable-fontpath' option when running the configure script.

Comment 31 Filipe Rosset 2010-04-13 17:42:57 UTC
Spec URL: http://filiperosset.fedorapeople.org/packages/flaw/flaw.spec
SRPM URL:
http://filiperosset.fedorapeople.org/packages/flaw/flaw-1.2.3-1.fc13.src.rpm

%changelog
* Tue Apr 13 2010 Filipe Rosset <rosset.filipe@gmail.com> - 1.2.3-1
- Update to version 1.2.3 upstream
- Update BuildRequires

Comment 32 Andrea Musuruane 2010-04-17 19:30:16 UTC
Everything is fine now.

APPROVED!

Comment 33 Filipe Rosset 2010-04-19 09:38:14 UTC
New Package CVS Request
=======================
Package Name: flaw
Short Description: A cross-platform, cross-compiler native makefiles generator
Owners: filiperosset
Branches: F-11 F-12 EL-5
InitialCC: filiperosset

Comment 34 Filipe Rosset 2010-04-19 09:40:28 UTC
Please ignore the comment #33
This is correct.

New Package CVS Request
=======================
Package Name: flaw
Short Description: Free top-down wizard battle game
Owners: filiperosset
Branches: F-11 F-12 F-13 devel EL-5
InitialCC: filiperosset

Comment 35 Andrea Musuruane 2010-04-19 09:45:06 UTC
Felipe, you do not have to specify the devel branch. It will always be created. Moreover you do not have to place yourself in the InitialCC list. You will always be included because you are the maintainer.

Comment 36 Filipe Rosset 2010-04-19 09:50:20 UTC
Ok, thanks Andrea.

Comment 37 Kevin Fenzi 2010-04-21 04:16:34 UTC
CVS done (by process-cvs-requests.py).


Note You need to log in before you can comment on or make changes to this bug.